#!/bin/bash
accumsize=$(($1))
echo
if [ "$accumsize" -lt "9" ]; then
	echo Aborted!  Size range 9-64.
	echo
	exit
fi

scoredir=test-s${accumsize}

# Combine all earlier findings into a single file
cat "${scoredir}/maxiter-s${accumsize}-"* >"${scoredir}/maxiter-s${accumsize}.out"

if [[ $? != 0 ]]; then
	echo Aborted!  Nothing done.
	echo
	exit
fi

# Check for spare mips - initial sample point
read cpu user nice system idle iowait irq softirq steal guest <"/proc/stat"
activeafter=$(( $user + $nice + $system + $softirq + $steal ))
totalafter=$(( $activeafter + $idle + $iowait ))


# Read one line at a time from the file, picking out the first three fields
while IFS=", " read -n 9 a b c
do
	read line
#echo $line
#echo $p1$p2$p3
#exit

# Extract fields from each line
#	a=$(echo $line | awk -F'[, \t]*' '{print $1}')
#	b=$(echo $line | awk -F'[, \t]*' '{print $2}')
#	c=$(echo $line | awk -F'[, \t]*' '{print $3}')
#echo $a$b$c

# Convert to integers
	a=$(($a))
	b=$(($b))
	c=$(($c))

# Variants:  Full sized generator word (minus the lsb for quality), truncated byte (adjustable position), truncated bit (not used, too slow).
	printf "Start combination [${a} ${b} ${c}] at "
	date +"%F %T"
	nice -11 ./testcase-xoroshiro.sh ${accumsize} ${a} ${b} ${c} "${scoredir}" &
	if [ "${accumsize}" -gt "11" ]; then
		nice -11 ./bytecase-xoroshiro.sh ${accumsize} ${a} ${b} ${c} $((${accumsize}-8)) "${scoredir}" &
		nice -11 ./bytecase-xoroshiro.sh ${accumsize} ${a} ${b} ${c} $(((${accumsize}-8)/2)) "${scoredir}" &
#		nice -11 ./bytecase-xoroshiro.sh ${accumsize} ${a} ${b} ${c} 1 "${scoredir}" &
	fi

# Check for spare mips
	while true
	do
		activebefore=$activeafter
		totalbefore=$totalafter
		sleep 4
		read cpu user nice system idle iowait irq softirq steal guest <"/proc/stat"
		activeafter=$(( $user + $nice + $system + $softirq + $steal ))
		totalafter=$(( $activeafter + $idle + $iowait ))

		cpuload=$(( 101 * ($activeafter - $activebefore) / ($totalafter - $totalbefore) ))
#echo cpuload=${cpuload}
		if [ "$cpuload" -lt "65" ];  then
			break
		fi
	done

done < "${scoredir}/maxiter-s${accumsize}.out"
